"""<one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2013 <name of author> Catrilas, aj_2745, ABT Benjaminsn
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>."""

import pygame,math,sprites,random
random.seed()

def Pigattack(pig):
    mouse=pygame.mouse.get_pos()
    x=pig.rect.center[0]-mouse[0]
    y=pig.rect.center[1]-mouse[1]
    if x==0:
        if y>0 or y==0:
            direction=0
        elif y<0:
            direction=math.radians(180)
    elif y==0:
        if x>0:
            direction=math.radians(90)
        else:
            direction=math.radians(270)
    else:
        direction=math.atan2(x,y)
    image=pygame.image.load('Bullet-1-Color-1.png').convert_alpha()
    return sprites.Bullet(pig.rect.center[0],pig.rect.center[1],image,1,direction,2,Straightbullet,None)

def Mobattack1(attacker,pig):
    x=pig.rect.center[0]-attacker.rect.center[0]
    y=pig.rect.center[1]-attacker.rect.center[1]
    if x==0:
        if y>0 or y==0:
            direction=0
        elif y<0:
            direction=math.radians(180)
    elif y==0:
        if x>0:
            direction=math.radians(90)
        else:
            direction=math.radians(270)
    else:
        direction=math.atan2(x,y)
    image=pygame.image.load('Bullet-2-Color-1.png').convert_alpha()
    return sprites.Bullet(pig.rect.center[0],pig.rect.center[1],image,1,direction,2,Straightbullet,None)

def Straightbullet(direction,center,target): #target isnt actually used for this but is there because other bullet ais may have it
    x=math.sin(direction)*2
    y=math.cos(direction)*2
    return (center[0]-x,center[1]-y)

def Pigmove((x,y),a,b,walls,sprite):
                keys=pygame.key.get_pressed()
                if keys[pygame.K_w] and not keys[pygame.K_s]:
                        sprite.rect.top-=2
                        if not pygame.sprite.spritecollide(sprite,walls,False):
                            y-=2
                        sprite.rect.top+=2
                if keys[pygame.K_a] and not keys[pygame.K_d]:
                        sprite.rect.left-=2
                        if not pygame.sprite.spritecollide(sprite,walls,False):
                            x-=2
                        sprite.rect.left+=2
                if keys[pygame.K_s] and not keys[pygame.K_w]:
                        sprite.rect.top+=2
                        if not pygame.sprite.spritecollide(sprite,walls,False):
                            y+=2
                        sprite.rect.top-=2
                if keys[pygame.K_d] and not keys[pygame.K_a]:
                        sprite.rect.left+=2
                        if not pygame.sprite.spritecollide(sprite,walls,False):
                            x+=2
                        sprite.rect.left-=2
                return 0,0,(x,y)
def Mobmoverandom((x,y),randlong,rand,walls,sprite):
    if randlong<1:
        rand=random.randint(1,8)
        randlong=random.randint(1,20)
    if rand==1:
        sprite.rect.left-=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            x-=2
    if rand==2:
        sprite.rect.top-=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            y-=2
    if rand==3:
        sprite.rect.left+=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            x+=2
    if rand==4:
        sprite.rect.top+=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            y+=2
    if rand==5:
        sprite.rect.top-=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            y-=2
        sprite.rect.left-=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            x-=2
    if rand==6:
        sprite.rect.left-=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            x-=2
        sprite.rect.top+=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            y+=2
    if rand==7:
        sprite.rect.top-=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            y-=2
        sprite.rect.left+=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            x+=2
    if rand==8:
        sprite.rect.left+=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            x+=2
        sprite.rect.top+=2
        if not pygame.sprite.spritecollide(sprite,walls,False):
            y+=2
    if sprite.rect.left<0:
        sprite.rect.left=0
    if sprite.rect.right>638:
        sprite.rect.right=638
    if sprite.rect.top<0:
        sprite.rect.top=0
    if sprite.rect.bottom>638:
        sprite.rect.bottom=638
    return rand,randlong,(x,y)
